/* 
Beszúrások
*/

#include <iostream>
#include <fstream>
using namespace std;

int const maxDim = 10000;

ifstream fin("pelda.in");

void beOlvasSorozat(int& n, int x[]){
	
	fin >> n;
	for (int i = 1; i <= n; i++)
		fin >> x[i];
}

void kiIrSorozat(int n, int x[]){

	for (int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

void beszurHatvanyokat(int &n, int a[]){

	for (int i = n; i > 0; i--){
		a[2 * i - 1] = a[i];
		int aux1 = a[i];
		int aux2 = 1;
		while (aux1 > 1){
			aux1 = aux1 / 2;
			aux2 = aux2 * 2;
		}
		a[2 * i] = aux2;
	}
	n = 2 * n;
}

int main(){
	int a[maxDim]; int n;

	beOlvasSorozat(n, a);
	kiIrSorozat(n, a);
	beszurHatvanyokat(n, a);

	cout << "A sorozat a beszurasok utan: " << endl;
	kiIrSorozat(n, a);
}


