/* 
Legyen a kvetkez alprogram, ahol az a bemeneti paramter termszetes szm (0 < a <= 30 000). 
a. Adjtok meg annak a feladatnak a szvegt, amelyet ez az algoritmus old meg.
b. Mit trt az F(2103) hvs? 
c. rjtok le az adott algoritmus rekurzv vltozatt, amelynek fejlce azonos az iteratv algoritmus fejlcvel.
*/

#include <iostream>

using namespace std;

int iterativFuggveny(int a){
// trti az adott szm pratlan rtk szmjegyeibl felptett szmot; ha nem ltezik egyetlen pratlan szmjegy sem, az rtk 0
 
int b = 0;
int p = 1;
	while (a > 0){
		int c = a % 10;
		if(c % 2 != 0){
			b = b + p * c;
			p = p * 10;
		}
		a = a / 10;
	}
	return b;
}

int rekurzivFuggveny(int a){
// trti az adott szm pratlan rtk szmjegyeibl felptett szmot; ha nem ltezik egyetlen pratlan szmjegy sem, az rtk 0

	if(a < 1)
		return a;
	else{
		int c = a % 10;
		if (c % 2 != 0)
			return c + 10 * rekurzivFuggveny(a / 10);
		else
			return rekurzivFuggveny(a / 10);
	}
}

int main(){	

int a;
	
	cout << "a = ";	cin >> a;

	cout << "Eredmeny az iterativ algoritmussal: ";
	cout << "b = " << iterativFuggveny(a) << endl;
	cout << "Eredmeny a rekurziv algoritmussal: ";		
	cout << "b = " << rekurzivFuggveny(a) << endl;	
}
