/*
Megfeleltetés
*/

#include <iostream>
#include <fstream>

using namespace std;

const int maxDim = 10001;
 
ifstream f("megf1.in");

void beOlvas(int & n, int x[]){
// beolvasás
  	
	f >> n;
  	for(int i = 1; i <= n; i++)
  		f >> x[i];
}

void scrie(int & n, int x[]){
// a bemeneti adatok kiírása
  	
	cout << n << endl;
  	for(int i = 1; i <= n; i++)
  		cout << x[i] << " ";
  	cout << endl;
}

bool megfelel(int n, int a[], int m, int b[], int & legtobb, int & k){
// vizsgáljuk a kért tulajdonságot és meghatározzuk a pozíciót a b sorozatban, ahol 
// az az érték található, amelyet elő lehet állítani a legtöbb (a sorozatban található) elem összeadásával

legtobb = 1;								// a leghosszabb tömbszakasz mérete 
int osszeadva;								// aktulis hossz
	if(m > n)								// ha b hosszabb, mint a, nem teljesíthető a tulajdonság
		return false;
	int j = 1;
	int i = 1;
	int kezd = 1;							// az aktuális tömbszakasz kezdő pozíciója
	while(j <= m){							// a b-nek még nem értünk a végére
		int aktualis = b[j];				// a b sorozat aktualis eleme
		int s = 0;							// az aktuális tömbszakasz összege
		bool vege = false;					// még nem találtuk meg a tömbszakaszt
		while(!vege && i<= n){				// az a-nak még nem értünk a végére
			s = s + a[i];					// a soron következő elemet a-ból az aktualis összeghez adjuk
			if(s > aktualis)				// ha az összeg meghaladja a b sorozat aktuális elemének értékét
				return false;				// nem teljesül a tulajdonság
			else{
				if(s == aktualis){			// ha s-ben megkaptuk a b sorozat aktuális elemének értékét
					osszeadva = i - kezd + 1;// meghatározzuk az aktuális tömbszakasz hosszát 
					if(osszeadva > legtobb){// aktualizáljuk a leghosszabb tömbszakasz hosszát
						legtobb = osszeadva;
						k = j;
					}
					j++;					// haladunk b-ben
					i++;					// haladunk a-ban
					kezd = i;				// a következő tömbszakasz kezdete
					vege = true;
				}
				else
					i++;
			}
		}
		if(j <= m && i > n)					// ha b-nek nincs vége, de a-nak igen
			return false;
		if(i <= n && j > m)					// ha a-nak nincs vége, de b-nek igen
			return false;
	}
	return true;
}

int main(){
int n, m, k, legtobb;
int a[maxDim], b[maxDim];

	beOlvas(n, a);
	beOlvas(m, b);

	scrie(n, a);
	scrie(m, b);
	
	if(megfelel(n, a, m, b, legtobb, k)){
		cout << "IGEN" << endl;
		cout << "k = " << k << endl;
		cout << "legtobb = " << legtobb << endl;
	}
	else
		cout << "NEM" << endl;
}