/*
Fénysugár
*/

#include <iostream>
#include <fstream>

using namespace std;

ifstream f("sugar0.in");

void beOlvas(int & a, int & b){

  	f >> a >> b;
}

void kiIr(int a, int b){

	cout << "Hosszusag = " << a << endl;
	cout << "Szelesseg = " << b << endl;
}

int lnko_1(int a, int b){
// ismételt osztásokkal

	int mar = a % b;
	while(mar != 0){
		a = b;
		b = mar;
		mar = a % b;
	}
	return b;
}

int lnko_2(int a, int b){
// ismételt kivonásokkal

	if(a == b && a == 0)
		return 1;
	if(a * b == 0)
		return a + b;
	while(a != b){
		if(a > b)
			a -= b;
		else
			b -= a;
	}
	return a;
}

int sugar(int a, int b){
// hányszor változtatja az irányt a fénysugár

int valtSz;
	int d = lnko_1(a, b);
	if(d == a)						// ha az a oldal osztója b-nek 
		valtSz = b / d - 1;
	else
		if(d == b)					// ha a b oldal osztója a-nak
			valtSz = a / d - 1;
		else
			valtSz = b / d + a / d - 2;			// ha egyik sem
	return valtSz;
}

int szim(int a, int b){
// a tükröződések szimulálása

int valtSz = 0;
int posX = 0;
int posY = 0;
    enum iranyTipusa {jobbraFel, jobbraLe, balraLe, balraFel};
    iranyTipusa irany = jobbraFel;
    bool vege = false; // még nem érkezett meg egy sarokba
    while(!vege)
        switch(irany){
            case jobbraFel:
                if(a - posY == b - posX) // sarokba ért
                    vege = true;
                else if(a - posY < b - posX){ // ütközik a felső oldalba
                    posX += a - posY;
                    posY = a;
                    irany = jobbraLe;
                    ++valtSz;
                }
                else{ // ütközik a jobb oldalba
                    posY += b - posX;
                    posX = b;
                    irany = balraFel;
                    ++valtSz;
                }
                break;

            case jobbraLe:
                if(posY == b - posX) // sarokba ért
                    vege = true;
                else if(posY < b - posX){ // ütközik az alsó oldalba
                    posX += posY;
                    posY = 0;
                    irany = jobbraFel;
                    ++valtSz;
                }
                else{ // ütközik a jobb oldalba
                    posY -= b - posX;
                    posX = b;
                    irany = balraLe;
                    ++valtSz;
                }
                break;

            case balraLe:
                if(posY == posX) // sarokba ért
                    vege = true;
                else if(posY < posX){ // ütközik az alsó oldalba
                    posX -= posY;
                    posY = 0;
                    irany = balraFel;
                    ++valtSz;
                }
                else{ // ütközik a bal oldalba
                    posY -= posX;
                    posX = 0;
                    irany = jobbraLe;
                    ++valtSz;
                }
                break;

            case balraFel:
                if(a - posY == posX) // sarokba ért
                    vege = true;
                else if(a - posY < posX){ // ütközik a felső oldalba
                    posX -= a - posY;
                    posY = a;
                    irany = balraLe;
                    ++valtSz;
                }
                else{ // ütközik a bal oldalba
                    posY += posX;
                    posX = 0;
                    irany = jobbraFel;
                    ++valtSz;
                }
                break;
        }
    return valtSz;
}

int main(){
int a, b;

	beOlvas(a, b);
	kiIr(a, b);
	
	cout << "A fenysugar " << sugar(a, b) << "-szer valtoztatta az iranyt." << endl;
	cout << "A fenysugar " << szim(a, b) << "-szer valtoztatta az iranyt." << endl;
}

