/*
Pascal hromszg 
*/

#include <iostream>

using namespace std;

const int maxDim = 33;

void PascalHaromszog(int r, int sorozat[]){
// kiszmtjuk a Pascal hromszg egy-egy sornak elemeit az eltte lev sor rtkeinek alapjn

	int ujSorozat[maxDim];
	sorozat[0] = 1; 
	sorozat[1] = 1;						// a hromszg 2. sora
	for(int k = 2; k <= r; k++){
		ujSorozat[0] = 1;
		ujSorozat[k] = 1;
			
		for(int i = 1; i < k; i++)		// az j sorozatot az eltte lev alapjn szmtjuk ki 
			ujSorozat[i] = sorozat[i - 1] + sorozat[i];
			
		for(int i = 0; i <= k; i++)		// az j sorozat elfoglalja a rgi helyt
			sorozat[i] = ujSorozat[i];
	}	
}

void kiirEredmeny(int n, int sorozat[]){
// kirjuk az r. sort a Pascal hromszgnek

	for(int i = 0; i <= n; i++)
		cout << sorozat[i] << " ";
	cout << endl;	
}

int main(){	
int r;
int sorozat[maxDim];

	cout << "r = ";	cin >> r;	
	PascalHaromszog(r, sorozat);
	kiirEredmeny(r, sorozat);
}
